#ifndef EFL_INPUT_STATE_EO_HH
#define EFL_INPUT_STATE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_input_state.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace input { 
struct State;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::input::State> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace input { 
struct State {
   ::efl::eolian::return_traits<bool>::type modifier_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<bool>::type lock_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_INPUT_STATE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::input::State() const;
   operator ::efl::input::State&();
   operator ::efl::input::State const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<State> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<State const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace input { 
struct State : ::efl::eo::concrete
{
   explicit State( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit State(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   State(State const& other) = default;
   State(State&& other) = default;
   State& operator=(State const& other) = default;
   State& operator=(State&& other) = default;
   State()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   State( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> State(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type modifier_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<bool>::type lock_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_INPUT_STATE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<State> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<State const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(State) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<State>::value, "");
} } 
#include "efl_input_state.eo.impl.hh"
#endif
